//
//  UITextField+Extension.m
//  EZOpenSDKDemo
//
//  Created by JuneCheng on 2021/8/12.
//  Copyright © 2021年 hikvision. All rights reserved.
//

#import "UITextField+Extension.h"

@implementation UITextField (Extension)

- (void)setPadding:(CGRect)rect {
    self.leftView = [[UIView alloc] initWithFrame:rect];
    self.leftViewMode = UITextFieldViewModeAlways;
}

- (void)setLeftPadding:(CGFloat)leftPadding {
    [self setPadding:CGRectMake(0, 0, leftPadding, 0)];
}

- (void)setBorderWidth:(CGFloat)borderWidth cornerRadius:(CGFloat)cornerRadius borderColor:(UIColor *)borderColor {
    self.layer.borderWidth = borderWidth;
    self.layer.cornerRadius = cornerRadius;
    self.layer.borderColor = borderColor.CGColor;
}

- (BOOL)shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string numAfterPoint:(int)num {
    /*
     * 不能输入.0-9以外的字符。
     * 设置输入框输入的内容格式
     * 只能有一个小数点
     * 小数点后最多能输入两位
     * 如果第一位是.则前面加上0.
     * 如果第一位是0则后面必须输入点，否则不能输入。
     */
    
    // 判断是否有小数点
    BOOL isHaveDian = [self.text containsString:@"."];
    if (string.length > 0) {
        //当前输入的字符
        unichar single = [string characterAtIndex:0];
        // 不能输入.0-9以外的字符
        if (!((single >= '0' && single <= '9') || single == '.')) {
            return NO;
        }
        // 只能有一个小数点
        if (isHaveDian && single == '.') {
            return NO;
        }
        // 如果第一位是.则前面加上0.
        if ((self.text.length == 0) && (single == '.')) {
            self.text = @"0";
        }
        // 如果第一位是0则后面必须输入点，否则不能输入。
        if ([self.text hasPrefix:@"0"]) {
            if (self.text.length > 1) {
                NSString *secondStr = [self.text substringWithRange:NSMakeRange(1, 1)];
                if (![secondStr isEqualToString:@"."]) {
                    return NO;
                }
            } else {
                if (![string isEqualToString:@"."]) {
                    return NO;
                }
            }
        }
        // 小数点后最多能输入num位
        if (isHaveDian) {
            NSRange ran = [self.text rangeOfString:@"."];
            // 由于range.location是NSUInteger类型的，所以这里不能通过(range.location - ran.location)>2来判断
            if (range.location > ran.location) {
                if ([self.text pathExtension].length > (num - 1)) {
                    return NO;
                }
            }
        }
    }
    
    return YES;
}

- (BOOL)shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string numMax:(int)numMax {
    // Prevent crashing undo bug – see note below.
    if (range.length + range.location > self.text.length) {
        return NO;
    }
    NSUInteger newLength = [self.text length] + [string length] - range.length;
    return newLength <= numMax;
}

@end
